$(function() {

  function prepare_dynamic_widgets()
  {
    $('[data-dynamic-display-parent]').off('change input').on('change input', function() {
      var sel1 = '[data-dynamic-display-child-of="' + $(this).attr('name') + '"]';
      var sel2 = '[data-dynamic-display-value="' + $(this).val() + '"]';
      var sel3 = '[data-dynamic-display-invert-value][data-dynamic-display-invert-value!="' + $(this).val() + '"]';
      var sel4 = '[data-dynamic-display-value-in*="' + $(this).val() + '"]';
      $(sel1).addClass('widget-hidden');
      $(sel1 + sel2).removeClass('widget-hidden');
      $(sel1 + sel3).removeClass('widget-hidden');
      $(sel1 + sel4).removeClass('widget-hidden');
    });
    $('[data-dynamic-display-child-of]').addClass('widget-hidden');
    $('select[data-dynamic-display-parent]').trigger('change');
    $('[data-dynamic-display-parent]:checked').trigger('change');
  }

  function prepare_autocomplete_widgets() {
    if (! $('select').select2) return;
    var select2_options = {
      language: {
        errorLoading: function() { return WCS_I18N.s2_errorloading; },
        noResults: function () { return WCS_I18N.s2_nomatches; },
        inputTooShort: function (input, min) { return WCS_I18N.s2_tooshort; },
        loadingMore: function () { return WCS_I18N.s2_loadmore; },
        searching: function () { return WCS_I18N.s2_searching; }
      }
    }
    if ($('select[data-autocomplete]').parents('.ui-dialog').length) {
      select2_options.width = '100%';
    }

    $('select[data-autocomplete]').each(function(idx, elem) {
      $(elem).select2(select2_options);
    });
  }

  function prepate_select_or_other_widgets() {
    $('.SingleSelectWidgetWithOther').each(function(idx, elem) {
      var $widget = $(elem);
      $widget.find('select').off('change input').on('change input', function() {
        var val = $(this).val();
        if (val == '__other') {
          $widget.find('.StringWidget').show();
        } else {
          $widget.find('.StringWidget').hide();
        }
      });
      $widget.find('select').trigger('change');
    });
  }

  function prepare_confirmation_buttons() {
    $('button[data-ask-for-confirmation]').off('click').on('click', function() {
      if (confirm(WCS_I18N.confirmation) != true) {
        return false;
      } else {
        return true;
      }
    });
  }

  $('[data-content-url]').each(function(idx, elem) {
    $.ajax({url: $(elem).data('content-url'),
            xhrFields: { withCredentials: true },
            async: true,
            dataType: 'jsonp',
            crossDomain: true,
            success: function(data) { $(elem).html(data.content); },
            error: function(error) { windows.console && console.log('bouh', error); }
           });
  });

  function prepare_widgets() {
    prepare_dynamic_widgets();
    prepare_autocomplete_widgets();
    prepate_select_or_other_widgets();
    prepare_confirmation_buttons();
  }

  prepare_widgets();
  $(document).on('wcs:dialog-loaded', prepare_widgets);
  $(document).on('wcs:new-widgets-on-page', prepare_widgets);
});
